SystemOrganization addCategory: #'Obj1-preguntados'!
SystemOrganization addCategory: 'Obj1-preguntados-model'!
SystemOrganization addCategory: 'Obj1-preguntados-specs'!

TestCase subclass: #TestCategoria
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-specs'!

!TestCategoria methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/25/2015 01:34'!
test_SiguientePreguntaFallaSiNoHayMasPreguntas
	|categoria pregunta|
	pregunta := Pregunta new.
	categoria := Categoria conPreguntas: { pregunta }.
	
	categoria siguientePregunta.

	self should: [categoria siguientePregunta] raise: NoQuedanPreguntasError! !

!TestCategoria methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/18/2015 12:30'!
test_SiguientePreguntaQuitaLaPreguntaDeLaCategoria
	|categoria pregunta1 pregunta2 siguiente|
	pregunta1 := Pregunta new.
	pregunta2 := Pregunta new.
	categoria := Categoria conPreguntas: { pregunta1. pregunta2 }.
	
	siguiente := categoria siguientePregunta.
	
	self deny: (categoria preguntas includes: siguiente)! !

TestCase subclass: #TestPreguntados
	instanceVariableNames: 'jugadorDesafiante otroJugador partida preguntaHistoria respuestaCorrecta preguntaHistoriaHelicoptero ruletaStub'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-specs'!

!TestPreguntados methodsFor: 'helpers' stamp: 'FedericoAloi 12/17/2015 14:52'!
avanzarAEtapaDuelo
	3 timesRepeat: [ self contestarBienPreguntaActual ].
	partida turnoActual etapa elegirDuelo! !

!TestPreguntados methodsFor: 'helpers' stamp: 'FedericoAloi 12/17/2015 17:36'!
avanzarAEtapaDueloYElegirCorona
	self avanzarAEtapaDuelo.
	otroJugador coronaGanada: (Categoria historia).
	partida turnoActual etapa elegirCorona: (Categoria historia)! !

!TestPreguntados methodsFor: 'helpers' stamp: 'FedericoAloi 12/8/2015 01:58'!
avanzarAObtencionDeCorona
	3 timesRepeat: [ self contestarBienPreguntaActual ].
	partida turnoActual etapa elegirCorona! !

!TestPreguntados methodsFor: 'helpers' stamp: 'FedericoAloi 11/24/2015 19:46'!
contestarBienPreguntaActual	
	| turno pregunta |
	turno := partida turnoActual.
	pregunta := turno pregunta.
	turno responderPreguntaCon: turno pregunta respuestaCorrecta.
	
	^ pregunta! !

!TestPreguntados methodsFor: 'helpers' stamp: 'FedericoAloi 11/24/2015 23:46'!
contestarMalPreguntaActual
	| turno |
	turno := partida turnoActual.
	turno responderPreguntaCon: (preguntaHistoria algunaRespuestaIncorrecta).
	
	^turno
	! !

!TestPreguntados methodsFor: 'helpers' stamp: 'FedericoAloi 12/17/2015 15:04'!
ganarCorona: categoria
	self avanzarAObtencionDeCorona.
	EtapaObtencionDeCorona elegirCorona: categoria.
	self contestarBienPreguntaActual! !

!TestPreguntados methodsFor: 'helpers' stamp: 'FedericoAloi 12/8/2015 01:36'!
preguntasDeHistoria
 ^{ 
		preguntaHistoria. 
		Pregunta 
			texto: 'De las siguientes personas, ¿quién nunca ganó el Premio Nobel de la Paz?'
			respuestaCorrecta: 'Carlitos Balá'
			eIncorrecta: 'Barack Obama'
			eIncorrecta: 'Rigoberta Menchú'
			eIncorrecta: 'Adolfo Pérez Esquivel'. 
		Pregunta 
			texto: '¿En qué ciudad japonesa cayó la primera bomba atómica, arrojada durante la Segunda Guerra Mundial?'
			respuestaCorrecta: 'Hiroshima'
			eIncorrecta: 'Nagasaki'
			eIncorrecta: 'Tokio'
			eIncorrecta: 'Yokohama'. 
		preguntaHistoriaHelicoptero.
		Pregunta 
			texto: '¿En qué año tuvo lugar el ataque a Pearl Harbor?'
			respuestaCorrecta: '1941'
			eIncorrecta: '1939'
			eIncorrecta: '1940'
			eIncorrecta: '1942'. 		
	}.! !

!TestPreguntados methodsFor: 'running' stamp: 'FedericoAloi 12/17/2015 17:46'!
setUp
	jugadorDesafiante := Jugador llamado: 'Fede'.
	otroJugador := Jugador llamado: 'Ari'.
	
	preguntaHistoria := Pregunta 
		texto: '¿En qué año fue proscripto el Peronismo?'
		respuestaCorrecta: '1955'
		eIncorrecta: '1954'
		eIncorrecta: '1956'
		eIncorrecta: '1953'.
		
	preguntaHistoriaHelicoptero := Pregunta 
			texto: '¿Qué presidente de la República Argentina terminó su mandato tras abandonar la Casa Rosada en helicóptero?'
			respuestaCorrecta: 'Fernando de la Rúa'
			eIncorrecta: 'Hector Cámpora'
			eIncorrecta: 'Néstor Kirchner'
			eIncorrecta: 'Eduardo Duhalde'.
		
	Categoria 
		conPreguntasDeHistoria: self preguntasDeHistoria
		conPreguntasDeGeografia: (PreguntasDummyFactory crearPreguntas: 2)
		conPreguntasDeCiencia: (PreguntasDummyFactory crearPreguntas: 2)
		conPreguntasDeDeportes: (PreguntasDummyFactory crearPreguntas: 2)
		conPreguntasDeArte: (PreguntasDummyFactory crearPreguntas: 2)
		conPreguntasDeEntretenimiento: (PreguntasDummyFactory crearPreguntas: 2).
	
	ruletaStub := RuletaStub new.
	ruletaStub siguienteResultadoCategoria: Categoria historia.
	
	EtapaGiroDeRuleta configurarRuleta: ruletaStub.
	
	partida := Partida con: jugadorDesafiante desafiaA: otroJugador! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 11/25/2015 00:12'!
test_AlComenzarUnTurnoElMismoSeEncuentraEnLaEtapaDeGiroDeRuleta
	self assert: partida turnoActual etapa equals: EtapaGiroDeRuleta! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 11/24/2015 23:27'!
test_AlContestarBienLaPreguntaSeEligeOtraPregunta
	| preguntaRespondidaCorrectamente |
	preguntaRespondidaCorrectamente := self contestarBienPreguntaActual.
	self deny: partida turnoActual pregunta = preguntaRespondidaCorrectamente! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 11/25/2015 00:13'!
test_AlContestarBienLaPreguntaSeSumaUnPuntoAlTurno
	self contestarBienPreguntaActual.
	self assert: EtapaGiroDeRuleta puntaje equals: 1! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 11/19/2015 16:57'!
test_AlContestarMalLaPreguntaCambiaElTurno
	| turnoAnterior |
	turnoAnterior := self contestarMalPreguntaActual.	
		
	self deny: (turnoAnterior = partida turnoActual)! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 11/19/2015 16:57'!
test_AlContestarMalLaPreguntaElNuevoTurnoEsDelOtroJugador
	| turnoAnterior |
	turnoAnterior := self contestarMalPreguntaActual.	
		
	self assert: (partida turnoActual jugadorActual) equals: (turnoAnterior jugadorSiguiente)! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 11/25/2015 00:13'!
test_AlContestarMalLaPreguntaNoSumaPuntosAlTurno
	| turnoAnterior |
	turnoAnterior := self contestarMalPreguntaActual.	
		
	self assert: EtapaGiroDeRuleta puntaje equals: 0.! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 11/24/2015 23:28'!
test_AlIniciarUnTurnoEnEtapaGiroLaPreguntaEstaEstablecida
	self assert: partida turnoActual pregunta equals: preguntaHistoria! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 11/18/2015 10:14'!
test_AlIniciarseUnaPartidaElPrimerTurnoCorrespondeAlJugadorDesafiante
	self assert: partida turnoActual jugador equals: jugadorDesafiante! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 11/25/2015 00:19'!
test_ContestarCorrectamenteLaPreguntaDeObtencionDeCoronaOtorgaLaCorona
	self ganarCorona: Categoria historia.
	self assert: jugadorDesafiante coronas asArray equals: { Categoria historia }! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 11/25/2015 00:18'!
test_ContestarCorrectamenteLaPreguntaDeObtencionDeCoronaVuelveElTurnoAlGiroDeRuleta
	self ganarCorona: Categoria historia.
	self assert: partida turnoActual etapa equals: EtapaGiroDeRuleta! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 12/17/2015 15:04'!
test_ElegirCategoriaEnEtapaObtencionDeCoronaConfiguraLaSiguientePregunta
	self avanzarAObtencionDeCorona.	
	EtapaObtencionDeCorona elegirCorona: (Categoria historia).

	self assert: partida turnoActual etapa pregunta equals: preguntaHistoriaHelicoptero ! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 12/17/2015 15:03'!
test_EnUnDueloNoSePuedeElegirUnaCoronaQueElOponenteNoTenga
	self avanzarAEtapaDuelo.
	self should: [ partida turnoActual etapa elegirCorona: (Categoria historia) ] raise: OponenteNoTieneCoronaSeleccionadaError! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 12/17/2015 15:25'!
test_EnUnDueloSePuedeElegirUnaCoronaQueElOponenteTenga
	self avanzarAEtapaDuelo.
	otroJugador coronaGanada: (Categoria historia).
	partida turnoActual etapa elegirCorona: (Categoria historia).
	
	self assert: (partida turnoActual etapa coronaElegida) equals: (Categoria historia)! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 12/17/2015 14:54'!
test_NoSePuedeJugarUnDueloSinElegirUnaCoronaDelOponente
	self avanzarAEtapaDuelo.
	self should: [ partida turnoActual pregunta ] 	raise: CoronaNoElegidaError! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 11/25/2015 01:32'!
test_PedirLaSiguientePreguntaEnObtencionDeCoronaFallaSiNoSeEligioLaCategoria
	self avanzarAObtencionDeCorona.
	
	self should: [ partida turnoActual pregunta ] 	raise: CoronaNoElegidaError! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 12/8/2015 02:11'!
test_SiElSorteoSaleCoronaSeAvanzaAEtapaDeSeleccion
	ruletaStub siguienteResultadoCorona.			
	self contestarBienPreguntaActual.
	
	self assert: partida turnoActual etapa class equals: EtapaSeleccionDueloOCorona 

! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 12/8/2015 02:11'!
test_TrasContestar3PreguntasCorrectamenteSeAvanzaAEtapaDeSeleccion
	3 timesRepeat: [ self contestarBienPreguntaActual ].
	self assert: partida turnoActual etapa class equals: EtapaSeleccionDueloOCorona ! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 12/8/2015 02:00'!
test_TrasContestar3PreguntasCorrectamenteYElegirCoronaSeAvanzaAEtapaDeCorona
	3 timesRepeat: [ self contestarBienPreguntaActual ].
	partida turnoActual etapa elegirCorona.
	self assert: partida turnoActual etapa equals: EtapaObtencionDeCorona! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 12/17/2015 15:24'!
test_TrasContestar3PreguntasCorrectamenteYElegirDueloSeAvanzaAEtapaDeDuelo
	3 timesRepeat: [ self contestarBienPreguntaActual ].
	partida turnoActual etapa elegirDuelo.
	self assert: partida turnoActual etapa equals: EtapaDuelo! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 12/17/2015 17:37'!
test_TrasElegirLaCoronaEnUnDueloSeConfiguranSeisPreguntas
	self avanzarAEtapaDueloYElegirCorona.
	self assert: (partida turnoActual etapa preguntas size) equals: 6! !

!TestPreguntados methodsFor: 'tests' stamp: 'FedericoAloi 11/18/2015 10:14'!
test_UnJugadorPuedeIniciarUnaPartidaDesafiandoAOtroJugador
	self assert: partida estaIniciada

! !

Object subclass: #Categoria
	instanceVariableNames: 'preguntas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

Categoria class
	instanceVariableNames: 'historia geografia ciencia deportes arte entretenimiento'!

Categoria class
	instanceVariableNames: 'historia geografia ciencia deportes arte entretenimiento'!

!Categoria class methodsFor: 'initialization' stamp: 'FedericoAloi 11/18/2015 11:57'!
conPreguntas: unasPreguntas 
	^(self new) conPreguntas: unasPreguntas ; yourself! !

!Categoria class methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 12/8/2015 01:39'!
conPreguntasDeHistoria: preguntasHistoria 
conPreguntasDeGeografia: preguntasGeografia
conPreguntasDeCiencia: preguntasCiencia
conPreguntasDeDeportes: preguntasDeportes
conPreguntasDeArte: preguntasArte
conPreguntasDeEntretenimiento: preguntasEntretenimiento
	historia := self conPreguntas: preguntasHistoria.
	geografia := self conPreguntas: preguntasGeografia.
	ciencia := self conPreguntas: preguntasCiencia.
	deportes := self conPreguntas: preguntasDeportes.
	arte := self conPreguntas: preguntasArte.
	entretenimiento := self conPreguntas: preguntasEntretenimiento! !

!Categoria class methodsFor: 'accessors' stamp: 'FedericoAloi 11/24/2015 23:43'!
historia
	^ historia! !

!Categoria class methodsFor: 'public' stamp: 'FedericoAloi 12/8/2015 01:40'!
todas
	^{historia. geografia. ciencia. deportes. arte. entretenimiento}! !

!Categoria methodsFor: 'initialization' stamp: 'FedericoAloi 11/19/2015 17:09'!
conPreguntas: unasPreguntas
	preguntas := OrderedCollection new.
	preguntas addAll: unasPreguntas! !

!Categoria methodsFor: 'accessors' stamp: 'FedericoAloi 11/18/2015 12:24'!
preguntas
	^ preguntas! !

!Categoria methodsFor: 'public' stamp: 'FedericoAloi 11/19/2015 17:09'!
siguientePregunta
	|siguiente|
	self validarQuedanPreguntas.	
	siguiente := preguntas first.
	preguntas remove: siguiente.
	^siguiente! !

!Categoria methodsFor: 'private' stamp: 'FedericoAloi 11/25/2015 01:36'!
validarQuedanPreguntas
	self preguntas ifEmpty: [NoQuedanPreguntasError signal]! !

Object subclass: #Etapa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

Etapa class
	instanceVariableNames: 'pregunta'!

!Etapa commentStamp: '<historical>' prior: 0!
Soy una etapa de juego. Denoto el estado del juego en un momento dado.!

Etapa class
	instanceVariableNames: 'pregunta'!

!Etapa class methodsFor: 'public' stamp: 'FedericoAloi 11/24/2015 22:49'!
pregunta
	^ pregunta ifNil: [ self preguntaNoEstablecida ]! !

!Etapa class methodsFor: 'public' stamp: 'FedericoAloi 12/17/2015 14:56'!
preguntaNoEstablecida
	CoronaNoElegidaError signal! !

!Etapa class methodsFor: 'initialization' stamp: 'FedericoAloi 12/5/2015 18:36'!
reiniciar
	pregunta := nil! !

Etapa subclass: #EtapaDuelo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

EtapaDuelo class
	instanceVariableNames: 'turno coronaElegida preguntas'!

EtapaDuelo class
	instanceVariableNames: 'turno coronaElegida preguntas'!

!EtapaDuelo class methodsFor: 'accessing' stamp: 'FedericoAloi 12/17/2015 17:26'!
coronaElegida
	^ coronaElegida! !

!EtapaDuelo class methodsFor: 'public' stamp: 'FedericoAloi 12/17/2015 17:41'!
elegirCorona: unaCategoria 
	(turno jugadorSiguiente tieneCoronaDe: unaCategoria)
		ifTrue: [ coronaElegida := unaCategoria . self elegirPreguntas ]
		ifFalse: [ OponenteNoTieneCoronaSeleccionadaError signal ]! !

!EtapaDuelo class methodsFor: 'private' stamp: 'FedericoAloi 12/17/2015 17:42'!
elegirPreguntas
	preguntas := Categoria todas collect: [ :categoria | categoria siguientePregunta ]! !

!EtapaDuelo class methodsFor: 'initialization' stamp: 'FedericoAloi 12/17/2015 15:23'!
en: unTurno
	^self enTurno: unTurno ; yourself! !

!EtapaDuelo class methodsFor: 'initialization' stamp: 'FedericoAloi 12/17/2015 15:23'!
enTurno: unTurno
	turno := unTurno! !

!EtapaDuelo class methodsFor: 'accessors' stamp: 'FedericoAloi 12/17/2015 17:37'!
preguntas
	^preguntas! !

!EtapaDuelo class methodsFor: 'public' stamp: 'FedericoAloi 12/17/2015 17:39'!
reiniciar
	super reiniciar.
	coronaElegida := nil.
	preguntas := Bag new! !

Etapa subclass: #EtapaGiroDeRuleta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

EtapaGiroDeRuleta class
	instanceVariableNames: 'puntaje ruleta'!

!EtapaGiroDeRuleta commentStamp: '<historical>' prior: 0!
Soy la etapa en la cual el jugador debe girar la ruleta!

EtapaGiroDeRuleta class
	instanceVariableNames: 'puntaje ruleta'!

!EtapaGiroDeRuleta class methodsFor: 'private' stamp: 'FedericoAloi 12/5/2015 18:45'!
avanzar
	self siguientePregunta.
	puntaje := puntaje + 1! !

!EtapaGiroDeRuleta class methodsFor: 'public' stamp: 'FedericoAloi 12/8/2015 01:54'!
avanzarAObtencionDeCoronaEn: unTurno 
	unTurno cambiarEtapaA: (EtapaSeleccionDueloOCorona en: unTurno)! !

!EtapaGiroDeRuleta class methodsFor: 'public' stamp: 'FedericoAloi 12/8/2015 01:23'!
avanzarEn: unTurno 
	(self etapaTerminadaPara: unTurno) 
		ifTrue: [ self avanzarAObtencionDeCoronaEn: unTurno ]
		ifFalse: [ ruleta sortearSiguienteEtapaPara: unTurno ]! !

!EtapaGiroDeRuleta class methodsFor: 'public' stamp: 'FedericoAloi 12/5/2015 18:34'!
configurarRuleta: unaRuleta
	ruleta := unaRuleta! !

!EtapaGiroDeRuleta class methodsFor: 'private' stamp: 'FedericoAloi 11/24/2015 23:34'!
etapaTerminadaPara: unTurno 
	^ puntaje = (self puntajeMaximoEtapa - 1)! !

!EtapaGiroDeRuleta class methodsFor: 'public' stamp: 'FedericoAloi 11/24/2015 21:46'!
preguntaNoEstablecida
	^ self error: 'Aún no se ha sorteado la pregunta'! !

!EtapaGiroDeRuleta class methodsFor: 'accessors' stamp: 'FedericoAloi 11/24/2015 23:03'!
puntaje
	^ puntaje! !

!EtapaGiroDeRuleta class methodsFor: 'constants' stamp: 'FedericoAloi 11/24/2015 19:55'!
puntajeMaximoEtapa
	^3! !

!EtapaGiroDeRuleta class methodsFor: 'initialization' stamp: 'FedericoAloi 12/5/2015 18:37'!
reiniciar
	self siguientePregunta.
	puntaje := 0! !

!EtapaGiroDeRuleta class methodsFor: 'private' stamp: 'FedericoAloi 12/5/2015 19:36'!
siguientePregunta
	pregunta := self sortearPregunta! !

!EtapaGiroDeRuleta class methodsFor: 'private' stamp: 'FedericoAloi 12/5/2015 18:34'!
sortearCategoria
	^ruleta sortearCategoria! !

!EtapaGiroDeRuleta class methodsFor: 'private' stamp: 'FedericoAloi 12/5/2015 18:37'!
sortearPregunta
	^(self sortearCategoria) siguientePregunta! !

Etapa subclass: #EtapaObtencionDeCorona
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

EtapaObtencionDeCorona class
	instanceVariableNames: 'categoriaElegida'!

EtapaObtencionDeCorona class
	instanceVariableNames: 'categoriaElegida'!

!EtapaObtencionDeCorona class methodsFor: 'public' stamp: 'FedericoAloi 11/25/2015 00:12'!
avanzarEn: unTurno
	unTurno jugadorActual coronaGanada: categoriaElegida.
	unTurno cambiarEtapaA: EtapaGiroDeRuleta! !

!EtapaObtencionDeCorona class methodsFor: 'public' stamp: 'FedericoAloi 12/17/2015 15:04'!
elegirCorona: unaCategoria 
	categoriaElegida := unaCategoria.
	pregunta := unaCategoria siguientePregunta ! !

Etapa subclass: #EtapaSeleccionDueloOCorona
	instanceVariableNames: 'turno'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

EtapaSeleccionDueloOCorona class
	instanceVariableNames: 'turno'!

EtapaSeleccionDueloOCorona class
	instanceVariableNames: 'turno'!

!EtapaSeleccionDueloOCorona class methodsFor: 'initialization' stamp: 'FedericoAloi 12/8/2015 02:09'!
en: unTurno 
	^self new enTurno: unTurno ; yourself! !

!EtapaSeleccionDueloOCorona methodsFor: 'public' stamp: 'FedericoAloi 12/8/2015 02:08'!
elegirCorona
	turno cambiarEtapaA: EtapaObtencionDeCorona ! !

!EtapaSeleccionDueloOCorona methodsFor: 'public' stamp: 'FedericoAloi 12/17/2015 15:21'!
elegirDuelo
	turno cambiarEtapaA: (EtapaDuelo en: turno)! !

!EtapaSeleccionDueloOCorona methodsFor: 'initialization' stamp: 'FedericoAloi 12/8/2015 02:08'!
enTurno: unTurno 
	turno := unTurno! !

!EtapaSeleccionDueloOCorona methodsFor: 'public' stamp: 'FedericoAloi 12/8/2015 02:11'!
reiniciar! !

Object subclass: #Jugador
	instanceVariableNames: 'nombre coronas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!Jugador commentStamp: '<historical>' prior: 0!
Soy un jugador del juego Preguntados!

!Jugador class methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/19/2015 17:19'!
llamado: unNombre
	^(self new) conNombre: unNombre ; yourself! !

!Jugador methodsFor: 'initializers' stamp: 'FedericoAloi 11/19/2015 17:22'!
conNombre: unNombre
	nombre := unNombre! !

!Jugador methodsFor: 'public' stamp: 'FedericoAloi 11/24/2015 23:58'!
coronaGanada: unaCategoria
	coronas add: unaCategoria! !

!Jugador methodsFor: 'accessors' stamp: 'FedericoAloi 11/24/2015 23:59'!
coronas
	^ coronas! !

!Jugador methodsFor: 'public' stamp: 'ArielAlvarez 10/27/2015 21:24'!
desafiaA: otroJugador 
	^Partida newConDesafiante: self yDesafiado: otroJugador! !

!Jugador methodsFor: 'initializers' stamp: 'FedericoAloi 11/24/2015 23:58'!
initialize
	coronas := Bag new! !

!Jugador methodsFor: 'public' stamp: 'FedericoAloi 12/17/2015 17:26'!
tieneCoronaDe: unaCategoria 
	^coronas includes: unaCategoria! !

Object subclass: #Partida
	instanceVariableNames: 'desafiante desafiado turno'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!Partida commentStamp: '<historical>' prior: 0!
Soy una partida de preguntados!

!Partida class methodsFor: 'initialization' stamp: 'FedericoAloi 12/5/2015 17:13'!
con: desafiante desafiaA: contrincante
	^(self new) inicializarConDesafiante: desafiante contra: contrincante ; yourself! !

!Partida methodsFor: 'public' stamp: 'ArielAlvarez 10/27/2015 21:25'!
estaIniciada
	^true! !

!Partida methodsFor: 'initialization' stamp: 'FedericoAloi 12/5/2015 17:20'!
inicializarConDesafiante: unJugador contra: otroJugador
	desafiante := unJugador.
	desafiado := otroJugador.
	self nuevoTurnoEntre: unJugador y: otroJugador.
	^self! !

!Partida methodsFor: 'public' stamp: 'ArielAlvarez 10/27/2015 21:40'!
jugador
	self shouldBeImplemented.! !

!Partida methodsFor: 'private' stamp: 'FedericoAloi 11/19/2015 16:44'!
nuevoTurnoEntre: unJugador y: otroJugador
	turno := (Turno new) inicializarConActual: unJugador ySiguiente: otroJugador enPartida: self! !

!Partida methodsFor: 'public' stamp: 'FedericoAloi 11/19/2015 16:46'!
siguienteTurno
	self nuevoTurnoEntre: (turno jugadorSiguiente) y: (turno jugadorActual)! !

!Partida methodsFor: 'public' stamp: 'AlvarezAriel 11/17/2015 22:36'!
turnoActual
	^turno
! !

Object subclass: #Pregunta
	instanceVariableNames: 'texto respuestas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!Pregunta class methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/18/2015 16:48'!
texto: unTexto respuestaCorrecta: textoCorrecta eIncorrecta: textoIncorrecta1 eIncorrecta: textoIncorrecta2 eIncorrecta: textoIncorrecta3
	|pregunta|
	pregunta := (self new) conTexto: unTexto yRespuestas: 
		{ RespuestaCorrecta conTexto: textoCorrecta },
		({ textoCorrecta. textoIncorrecta1. textoIncorrecta2. textoIncorrecta3 } collect: [ :t | RespuestaIncorrecta conTexto: t ]).
		
	^pregunta! !

!Pregunta methodsFor: 'accessors' stamp: 'FedericoAloi 11/18/2015 16:58'!
algunaRespuestaIncorrecta
	^respuestas last! !

!Pregunta methodsFor: 'initialization' stamp: 'FedericoAloi 11/18/2015 16:50'!
conTexto: unTexto yRespuestas: unasRespuestas
	texto := unTexto.
	respuestas := OrderedCollection new.
	respuestas addAll: unasRespuestas ! !

!Pregunta methodsFor: 'accessors' stamp: 'FedericoAloi 11/18/2015 16:47'!
respuestaCorrecta
	^respuestas first! !

Object subclass: #PreguntasDummyFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-specs'!

!PreguntasDummyFactory class methodsFor: 'private' stamp: 'FedericoAloi 12/17/2015 17:51'!
crearPregunta
	^Pregunta texto: 'bla bla bla' respuestaCorrecta: 'correcta' eIncorrecta: 'incorrecta' eIncorrecta: 'incorrecta' eIncorrecta: 'incorrecta'! !

!PreguntasDummyFactory class methodsFor: 'public' stamp: 'FedericoAloi 12/17/2015 17:53'!
crearPreguntas: cantidadPreguntas
	^(1 to: cantidadPreguntas) collect: [ :num | self crearPregunta ]! !

Object subclass: #Respuesta
	instanceVariableNames: 'texto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!Respuesta class methodsFor: 'initialization' stamp: 'FedericoAloi 11/18/2015 11:00'!
conTexto: unTexto
	^(self new) conTexto: unTexto ; yourself! !

!Respuesta methodsFor: 'initialization' stamp: 'FedericoAloi 11/18/2015 11:00'!
conTexto: unTexto
	texto := unTexto ! !

Respuesta subclass: #RespuestaCorrecta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!RespuestaCorrecta methodsFor: 'public' stamp: 'FedericoAloi 11/18/2015 16:55'!
fueElegidaEn: unTurno 
	unTurno preguntaRespondidaCorrectamente! !

Respuesta subclass: #RespuestaIncorrecta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!RespuestaIncorrecta methodsFor: 'public' stamp: 'FedericoAloi 11/18/2015 16:59'!
fueElegidaEn: unTurno 
	unTurno preguntaRespondidaIncorrectamente ! !

Object subclass: #Ruleta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!Ruleta methodsFor: 'private' stamp: 'FedericoAloi 12/8/2015 01:26'!
seDetuvoEnCorona
	^(0 to: Categoria todas size) atRandom = 0! !

!Ruleta methodsFor: 'public' stamp: 'FedericoAloi 12/5/2015 18:40'!
sortearCategoria
	^Categoria todas anyOne! !

!Ruleta methodsFor: 'public' stamp: 'FedericoAloi 12/8/2015 01:25'!
sortearSiguienteEtapaPara: unTurno 
	self seDetuvoEnCorona 
		ifTrue: [ EtapaGiroDeRuleta avanzarAObtencionDeCoronaEn: unTurno ]
		ifFalse: [ EtapaGiroDeRuleta avanzar ]
		! !

Ruleta subclass: #RuletaStub
	instanceVariableNames: 'proximoCorona proximaCategoria'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-specs'!

!RuletaStub methodsFor: 'public' stamp: 'FedericoAloi 12/8/2015 01:30'!
seDetuvoEnCorona
	^proximoCorona ! !

!RuletaStub methodsFor: 'public' stamp: 'FedericoAloi 12/8/2015 01:29'!
siguienteResultadoCategoria: unaCategoria 
	proximoCorona := false.
	proximaCategoria := unaCategoria! !

!RuletaStub methodsFor: 'public' stamp: 'FedericoAloi 12/5/2015 19:14'!
siguienteResultadoCorona
	proximoCorona := true! !

!RuletaStub methodsFor: 'public' stamp: 'FedericoAloi 12/8/2015 01:29'!
sortearCategoria
	^proximaCategoria ! !

Object subclass: #Turno
	instanceVariableNames: 'jugadorActual jugadorSiguiente etapa partida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!Turno commentStamp: '<historical>' prior: 0!
Soy un turno en una partida. !

!Turno methodsFor: 'public' stamp: 'FedericoAloi 11/18/2015 12:04'!
avanzar
	etapa avanzarEn: self! !

!Turno methodsFor: 'public' stamp: 'FedericoAloi 12/5/2015 18:39'!
cambiarEtapaA: unaEtapa
	unaEtapa reiniciar.
	etapa := unaEtapa! !

!Turno methodsFor: 'accesing' stamp: 'ArielAlvarez 10/28/2015 01:44'!
etapa
	^etapa! !

!Turno methodsFor: 'initialization' stamp: 'FedericoAloi 11/25/2015 00:13'!
inicializarConActual: aJugador ySiguiente: aJugador2 enPartida: unaPartida
	jugadorActual := aJugador.
	jugadorSiguiente := aJugador2.
	partida := unaPartida.
	self cambiarEtapaA: EtapaGiroDeRuleta.
	^self! !

!Turno methodsFor: 'public' stamp: 'ArielAlvarez 10/27/2015 21:44'!
jugador
	^jugadorActual ! !

!Turno methodsFor: 'accessors' stamp: 'FedericoAloi 11/19/2015 16:47'!
jugadorActual
	^ jugadorActual! !

!Turno methodsFor: 'accessors' stamp: 'FedericoAloi 11/19/2015 16:46'!
jugadorSiguiente
	^ jugadorSiguiente! !

!Turno methodsFor: 'accessors' stamp: 'FedericoAloi 11/24/2015 22:54'!
pregunta
	^ etapa pregunta! !

!Turno methodsFor: 'public' stamp: 'FedericoAloi 11/24/2015 23:05'!
preguntaRespondidaCorrectamente
	self avanzar! !

!Turno methodsFor: 'public' stamp: 'FedericoAloi 11/19/2015 16:46'!
preguntaRespondidaIncorrectamente
	partida siguienteTurno
	! !

!Turno methodsFor: 'public' stamp: 'FedericoAloi 11/18/2015 16:54'!
responderPreguntaCon: unaRespuesta
	unaRespuesta fueElegidaEn: self! !

Error subclass: #CoronaNoElegidaError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!CoronaNoElegidaError methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/25/2015 01:31'!
messageText
	^'Aún no se ha seleccionado la corona por la cual se desea participar'! !

Error subclass: #NoQuedanPreguntasError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!NoQuedanPreguntasError methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/25/2015 01:36'!
messageText
	^'No quedan más preguntas en esta categoría'! !

Error subclass: #OponenteNoTieneCoronaSeleccionadaError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!OponenteNoTieneCoronaSeleccionadaError methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 12/17/2015 15:06'!
messageText
	^'El oponente no posee la corona que se desea elegir'! !
